.psx
.open "mod_output_3_md",0x00000000

;; Code in main executable should start around 2E9E0.

;; #################################
;; New Hitstun
;; #################################
;;
;; Only apply hitstun to player.
lui t9, 0x800F ;; If the player is getting attacked, A2 is equal to 800FDF58 by the point that this is called. 800FDF58 is the start address for the block of player stats.
ori t9, 0xDF58
bne a2, t9, r_hitstun
nop
  jal $8008b870
  addu a0, a2, zero
r_hitstun:
j 0x8008ad30
nop
nop
  
  nop
  nop		
  nop			
  nop			
  nop
  
;; #################################
;; New damage. 
;; Note that the first branch does not follow these conventions.
;; t9 = Value in the target pointer (80123b2c).
;; t8 = Value in the attacker pointer (80123b28). / Plunge multiplier value.
;; t7 = Attack type (just the last byte).
;; t6 = 0x8012, which is the base address for the above three values.
;; t5 = Temporary comparison value.
;; t4 = Plunge/combo multiplier offset.
;; #################################
;; 
;; New damage calculation function. Multiplies all damage by 5 when directed at the player.
lw v0, 0x0004(v1) 	;; %%Original code.%%
					;; There was originally a NOP after this.
					
lui t6, 0x8012 		;; Initialize t6.
lw t9, 0x3B2C(t6)	;; Load in target pointer.

ori t5, t6, 0x3b30  ;; Load the constant address of the Player into the comparison register.
  
bne t5, t9, player_attacking 	;; Is the target pointer (t9) set to the player (t5)? If so, more damage is done to the player.
lw t8, 0x3B28(t6)			;; Use the delay slot to load the Attacker value into t8, for the next check.
  lbu t9, 0x800435E8
  nop
  multu a3, t9  		 	;; Multiply player level by damage done.
    srl t9,t9,4   			;; Divide player level by 16. Doing this here because of how MFLO works I guess?
    addiu t9,t9,0x2 		;; Add two to shift p level
  mflo t8     				;; ... then store it in t8.
  sll a3,t8,1   			;; Multiply value by 3.
  addu a3,a3,t8
  srl a3, a3, 3 			;; Divide by 8.
  sll t9,t9,3     			;; Multiply by 8.
  addu a3,a3,t9   			;; Put back into a3.
  j 0x800b30ec 				;; Return to where the code left off.
  nop ;;srl a3,a3,1				;; Divide a3 by 2, since the attack damage is still too high.
  
player_attacking:  
  lbu t7, 0x3B24(t6)			;; Load in the attack type (there might be a load delay from lw t8, 0x3B28(t6) here.

  bne t5, t8, attack_eof	;; Determine if the player is attacking.
  addi t7, t7, -0x80		;; Normalize t7. Attack identifiers go from d0 to 48 or 50 to to c8. We want to establish a single range that covers both.
    bgtz t7, is_l_1			;; If t7 > 0, nothing else needs to be done on it. Values must be in the range 50, 58, 60, 68, 70, 78, 30, 38, 40, 48 now.
    addi t5, zero, 0x50			;; Take advantage of the branch delay to load in the first comparison value.
	  addi t7, t7, 0x80			;; If t7 was less that zero, re-add 80 to it. Values must be in the range 50, 58, 60, 68, 70, 78, 30, 38, 40, 48 now.
	
  is_l_1:
	lui t4, 0x8004			;; Load in start of plunge multiplier address. -- Actually resolves to 8003 after I get the offsets from this I want.
	nop 					;;add t9, a3, zero			;; Store attack value in t9. THIS ISN'T USED ANYMORE.

	lw t8, 0xE48c(t4)		 ;; Load the current plunge combo value into t8.
	
	  bne t7, t5, is_normal
		addi t5, zero, 0x30
		sra a3, a3, 1  		;; Do 1/2 damage.
		addi t8, zero, 0x0 	;; Set the plunge multiplier to 0. This means a plunge can't be done until at least L2 is hit. If I need space this can be replaced with just writing 0 to the multiplier address
		beq zero, zero, end_and_write_attack  ;; Done calculating stuff. Go home. Note that these go to end_and_write_attack now, so that ANY attack is stored as the last attack. This prevents sitations where the user does an uppercut, loses the modifier, does a full quick attack combo, and uppercuts again. This should be allowed, however the old version only wrote to Last Attack on plunges, meaning the second uppercut would get zero'd out.
		sw t8, 0xE48c(t4)		;; Store the new plunge multiplier.
	  
  is_normal:
    bne t7, t5, is_l_2_or_more
      addi t5, zero, 0x57   ;; Store the lower end of the remaining quick attack levels in t5.
	  sll a3, a3, 1			;; Double the damage, since standing normal makes you REALLY vulnerable.
	  beq zero, zero, end_and_write_attack   		;; Done calculating stuff. Go home.    	If j doesn't work, just use beq zero, zero, end_and_write_attack instead.
      sw t8, 0xE48c(t4)		;; Zero out the new plunge multiplier.
	  
  is_l_2_or_more:
	addi t3, zero, 0x79		;; Store the upper end of the remaining quick attack levels in t3.
    slt t2, t5, t7			;; Set t2 to 1 if t7 is less than t3.
    slt t3, t7, t3 			;; Set t3 to 1 if t5 is less than t7. This means that t7 is between 58 and 78.
    and t2, t2, t3			;; t2 is set to 1 if both t2 and t3 were 1.
	
	beq t2, zero, is_uppercut_or_thrust	;; Attack not in range to be a quick attack
      addi t3, zero, 0x49  				;; Set t3 to be the upper end of the plunge attacks.
	  addi t8, t8, 0x1	;; Add 1 to the combo multiplier. Do this before multiplying, because the previous value of the multiplier may have been 0.
	  multu a3, t8		;; Multiply the damage by the combo multiplier.
	  mflo a3			;; This shouldn't ever extend past the low bits.
	  nop 				;; No longer dividing damage by 2. Dividing it by two wasn't a fun damage curve. ;;sra a3, 1			;; Divide a3 by 2.
	  beq zero, zero, end_and_write_attack   ;; Done calculating stuff. Go home. 
	  sw t8, 0xE48c(t4)		;; Store the new plunge multiplier. 	  
 
  
  is_uppercut_or_thrust:
	addi t5, zero, 0x30		;; Set t5 to be the lower end of the plunge attack values.
    slt t2, t5, t7			;; Set t2 to 1 if t7 is less than t5.
    slt t3, t7, t3 			;; Set t3 to 1 if t3 is less than t7. This means that t7 is between 30 and 48.
    and t2, t2, t3			;; t2 is set to 1 if both t2 and t3 were 1.
	beq t2, zero, zero_and_write_attack ;; Attack wasn't in range. Don't mod the value. Jump ahead to zero out the multiplier though. Can't do that logic here, since this would zero out the multiplier when checking to see if a plunge attack occurred, which isn't what we want to happen -- multiplier decays when walking.
	  nop
	  lw t2, 0xE488(t4)		;; Load the previous attack value into t2.
	  nop
	  bne t2, t7, diff_plunge_done	;; The previous plunge attack and current one were the same; zero out the plunge/combo multiplier and do no damage.
	  nop
	    sw zero, 0xE48c(t4) ;; Zero out the plunge multiplier.
		add t8, zero, zero	;; Zero out t8.
	  diff_plunge_done:
	    multu a3, t8			;; Apply the plunge multiplier.
	    mflo a3				
	    sra a3, a3, 1			;; Divide a3 by two, after applying the multiplier. Dividing by four makes this too weak.

zero_and_write_attack:
  sw zero, 0xE48c(t4)    ;; Some other attack -- either an ST or plunge/tech combo or magic -- must have occurred, so zero out the plunge multiplier. 		
end_and_write_attack:
  sw t7, 0xE488(t4)		;; Store t7, the current attack, into the previous attack field.		
attack_eof:
  j 0x800b30ec ;; Return to where the code left off.
  nop
  
;;nop -- Removed when moving the write to the previous attack fiedl to the end.
;;nop -- Removed when moving code to zero out STs/other plunges to the end.
nop
nop
nop
nop
nop
nop

;; #################################
;; New Game Over
;; #################################
;;
jal 0x800b6334 			;; This function determines if you get a gameover.
nop
lui t9, 0x8010 			;; Load player health address into memory.
lw t9, 0x5AE4(t9)      	;; ...
nop

bne t9, zero, no_gameover 	;; Do the next bit if player health == 0.
lui t9, 0x8004 				;; Start setting stuff up to clear out Battle flag.
  addiu v0, zero, 0x0001 	;; Set v0 to 1, which triggers a game over. NOTE: THIS CANNOT GO IN THE DELAY SLOT FOR THE BNE!
  sw zero, 0xe490(t9) 		;; Clear battle flag.
  lui t9, 0x8004			;; Zero out the plunge modifier. The last attack value doesn't need to be cleared -- if the player ended the last combat with a plunge and started combat with the same plunge, the plunge would do zero damage anyway because the combo modifier is set to 0.
  sw zero, 0xE48c(t9)
no_gameover:
j 0x800b5850
nop
nop
nop

;; #################################
;; New Player Movement -- Horizontal
;; #################################
;;
lw v0, 0x0020(sp)
nop
;; May need some additional checks if the player can't move all the way to the right or left.
lui t9, 0x8003 
ori t9, 0xe490
lw t9, 0x0000(t9)
nop

beq t9, zero, ph_movement_f ;; if t9/80105AF0 == zero, we're not in combat. I don't know if this really works out or not, but this is what I've observed.
lui t9, 0x800F           ;; set up t9 for comparison in delay slot.
  ori t9, 0xDF58
  lw t9, 0x0000(t9)      ;; Delay slow -- Load the existing value at 800FDF58into t9
  nop                  ;; Load delay thing.
  sub t9, t9, v0       ;; Subtract v0 from t9 and store it in t9 (subtract old position from new position). Signedness matters.
  sra t9,t9,1          ;; Divide t9 by two. I think sra preserves signedness.
  lui t8, 0x8004		;; This + the Next three lines subtract the plunge combo by 1 -X-OLD-X- halve the plunge combo. 
  ;;lw t7, 0xE48C(t8)		;; Putting this here due to load delay.
  add v0,v0,t9         ;; If new pos < old pos, the player moved left, so old - new = positive value. Adding to the new position makes the player move less far to the left. Same applies in reverse, since t9 would be negative now if the player moved right.
  ;;sra t7, t7, 1
  ;;sw t7, 0xE48c(t8)
  
ph_movement_f: ;; Put another jump here that bypasses the entire movement bit when we're in combat?
j 0x8008e5c0 ;; Jump back to the write statement. ;; 8e5c8 is the jump
nop
nop
nop
nop
nop ;; Added by taking out plunge reduction.
nop ;; Added by taking out plunge reduction.
nop ;; Added by taking out plunge reduction.

;; #################################
;; New Player Movement -- Vertical
;; #################################
;;
;; Jump statement here is at 8008e5c8, followed by a nop at 8008e5cc.
;; The load statement is left as is -- we're instead replacing the jump that occurred after it.
lui t9, 0x8004
lw t9, 0xe490(t9)
nop

beq t9, zero, pv_movement_f ;; if t9/80105AF0 == zero, we're not in combat. I don't know if this really works out or not, but this is what I've observed.
lui t9, 0x8010           ;; set up t9 for comparison in delay slot.
  lw t9, 0xDF60(t9)      ;; Delay slow -- Load the existing value at 800FDF60 -- player's Y-pos -- into t9
  nop                  ;; Load delay thing.
  sub t9, t9, v0       ;; Subtract v0 from t9 and store it in t9 (subtract old position from new position). Signedness matters.
  sra t9,t9,1          ;; Divide t9 by two. I think sra preserves signedness.
  lui t8, 0x8004		;; This + the Next three lines halve the plunge combo.
  ;;lw t7, 0xE48c(t8)		;; Putting this here due to load delay.  
  add v0,v0,t9         ;; If new pos < old pos, the player moved left, so old - new = positive value. Adding to the new position makes the player move less far to the left. Same applies in reverse, since t9 would be negative now if the player moved right.
  ;;sra t7, t7, 1
  ;;sw t7, 0xE48c(t8)

pv_movement_f: ;; Put another jump here that bypasses the entire movement bit when we're in combat?
j 0x8008e630      ;; Original code ended in a jump statement with the X-position
sw v0, 0x0008(s0) ;; Write new position into memory.
nop
nop
nop
nop
nop ;; Added by taking out plunge reduction.
nop ;; Added by taking out plunge reduction.
nop ;; Added by taking out plunge reduction.

;; #################################
;; New Enemy Movement -- Horizontal/New player plunge movement (same function)
;; #################################
;;
lw v0, 0x0000(s3) ;; Original code.
lbu a0, 0x003a(s2)
;; May need some additional checks if the player can't move all the way to the right or left.
lui t9, 0x8003 
ori t9, 0xe490		;; I can probably remove this ori. lui in 8004 and just use e45C as an offset on the lw.
lw t8, 0x0000(t9)
ori t9, s2, 0xDF58 ;; Set t9 to the address for the player position. This is assuming that s2 will always start with 800f at this point. Which should be okay -- s2 is only storing position information, and all position addresses start with 800f.
;; Combat flag is needed, as this handles pet and NPC movement too.
beq t8, zero, mh_movement_p ;; if t8/80105AF0 == zero, we're not in combat. I don't know if this really works out or not, but this is what I've observed.
lw t8, 0x0000(s2)           ;; Use delay slot to load current position into t8.
  beq t9, s2, mh_movement_f ;; If t9 == s2, the player is moving, so don't do anything. Subbing stuff from t8 is harmless after this
  sub t8, v0, t8       ;; Subtract t8 from v0 and store it in t8 (subtract new position from old position). Signedness matters.
  ;sra t8,t8,1          Temporarily disabling this -- should make enemies move faster. ;; Divide t8 by two. I think sra preserves signedness.
  beq zero, zero, mh_movement_f	;; Bypass reducing the combo multiplier, since the enemy moved.
  add v0,v0,t8         ;; If new pos < old pos, the player moved left, so old - new = positive value. Adding to the new position makes the player move less far to the left. Same applies in reverse, since t9 would be negative now if the player moved right.
  
mh_movement_p:
  lui t8, 0x8004		;; This + the Next three lines halve the plunge combo.
  lw t7, 0xE48c(t8)		;; Putting this here due to load delay.  
  nop
  sra t7, t7, 1
  sw t7, 0xE48c(t8)  
mh_movement_f: ;; Put another jump here that bypasses the entire movement bit when we're in combat?
j 0x80098688 ;; Jump back to the write statement. ;; 8e5c8 is the jump
;;nop ;; REmoved by new plunge reduction code.
;;nop ;; Removed by new plunge reduction code.
;;nop ;; Removed by new plunge reduction code.
;;nop ;; Removed by new plunge reduction code.
;;nop ;; Removed by new plunge reduction code.
;;nop ;; Removed for load delay in new plunge reduction code.
nop
nop
nop

;; ### COMBAT FLAG HAD TO MOVE BECAUSE IT DOESN'T DEFAULT TO A VALUE I CAN USE OR SOMETHING. ###
;; ### THE OFFSETS CHANGED THOUGH SO IT WILL NEED TO MOVE TO SOMEWHERE ELSE IN MY OWN CODE   ###
;; #################################
;; New Enemy HP
;; #################################
;;
;; Actual HP mod will come later. This just sets the battle flag right now.
nop			;;;;; ***###%%% 8003E488: Reserved for last attack flag.													%%%###***---
nop			;;;;; ***###%%% 8003E48C: Currently reserved for plunge lock flag flag. OLD POsition was 8003E454. 	%%%###***---
nop			;;;;; ***###%%% 8003E490: THIS NOP IS RESERVED FOR STORING THE COMBAT FLAG. DO NOT JUMP HERE. 			%%%###***---
lui t9, 0x8003 ;; Was 800b. Actually loading in 8003, but E414 goes negative so this needs to be 8004.
ori t9, 0xe490 ;; Was 41a4 ;;0x8003e45C is new combat flag.
sw a0, 0x0(t9)
addu a0, zero, zero ;Original code. We want to use a0 before it gets zeroed out, though.
jal 0x800bd414 ; Original code.
addiu a1,zero,0x2938 ; Original code.
j 0x800b41a8 ; return to function.
nop ;; Following spaces are so I can add to this function later.
nop ;; load level
nop ;; mult
nop
nop
nop ;; save
nop
nop
nop

;; #################################
;; Disable in-combat flag
;; #################################
;;
lw v0, 0x0000(v1) ;; this previously had a NOP after it, that isn't necessary now.
lui t9, 0x8003
ori t9, 0xe490
lui t8, 0x8004
sw zero, 0x0(t9)
sw zero, 0xE48C(t8)		;; Clear out the plunge modifier.
jr ra
;;j 0x800b4658
nop                ;; Variant for usage in the Game Over function.
nop ;; this previously had a NOP after it, that isn't necessary now.
nop

;; #################################
;; Disable ST gain when plunge combo is zero.
;; #################################
;;
;; I believe this needs to go at 800b5f10.
lui t9, 0x8004		;; Start loading in the combo multiplier.
lw t8, 0xE48C(t9)
sllv v0, v0, a0		;; Original code that got replaced by the jump. This is going in the delay slot for the above load from memory.
bne t8, zero, add_st_meter
  nop
  add v0, zero, zero  ;; Zero out the ST gain.
add_st_meter:
addu v1, v1, v0		;; Original code. V1 should be the ST total, and v0 is what is being added to it I believe?
j 0x800b5f18
nop
nop
nop
nop
nop
nop
nop
nop


;; Relacement jumps

;; New Hitstun

;; Short circuit the original hitstun function so we can run some new code to only apply hitstun to the player.
;; Replace:
;; Original Opcodes: 1c2e020c2120c000.
;; Offset in Field: 3b0b8
j 0x8003e1e0 ;; This is in the main executable. Offset 2E9E0 in bin.
nop

;; New damage
;; Short circuit to new damage function.
;; Replace:
;; Original Opcodes: [00000000]0400628C00000000[23104700]
;; Offset in Field: 63474
j 0x8003e218  ;; 2ea00
nop

;; New Game Over
;; Replace:
;; Original Opcodes: cdd8020c00000000
;; Offset in Field: 65BD8
j 0x8003e34c
nop

;; New Movement -- Horizontal
;; Replace:
;; Original Opcodes: [0700401021200002]2000a28f00000000
;; Offset in Field: 3e948
j 0x8003E388 ;; This is in the main executable. Offset 2ea84 in bin.
nop


;; New Movement -- Vertical
;; Replace:
;; Original Opcodes: 8c390208080002ae
;; Offset in Field: 3e958
j 0x8003e3e4 ;; This is in the main executable. Offset 2ea84 in bin.
nop

;; New Movement -- Monster
;; Replace:
;; Original Opcodes: [F761020C2130E0021500401421204002]0000628E3A004492
;; Offset in Field: 48A10
j 0x8003e434 ;; This is in the main executable. Offset 2ea84 in bin.
nop

;; New HP
;; Replace:
;; Original: 2120000005f5020c[38290524]
;; Offset in Field: 6452c
j 0x8003e494 ;; 2eab8 in bin. ;; e45C is the new combat flag.
nop

;; Un-set battle flag.
;; Replace:
;; Original: [c31f020c212000022118400004007110]0000628c00000000.
;; Offset in Field: 649e0
jal 0x8003e4d4
;;j 0x8003E2E0 ;; 
nop

;; Don't add ST when the plunge combo is at zero.
;; Replace:
;; Original: [4800a394]0410820021186200[4800A3A4]
;; Offset in Field: 662a0
jal 0x8003e4fc
;;j 0x8003E2E0 ;; 
nop

;; Terminal pair of nops.
nop
nop
.close


;; Un-set battle flag.
;;;; BELOW BIT ALL NEEDS CHANGED ;;;;
;; Put in the delay slot after 800b4648.
;; After [c31f020c212000022118400004007110]0000628c00000000.
;; 649dc in the field.bin